/*  *************************************** */
/*  ***  LIFE          converted 4-85   *** */
/*  ***                                 *** */
/*  ***  Peter D. Matthews, Jr.         *** */
/*  *************************************** */

/* BASIC_C library from C_Source */
#include <bas.h>

/* - - - - - - - - - - - - - - - - - - - - - - - - - - -

                    Modifiable Parameters                
*/
#define FORE 1
        /* color of dots in medium res graphics mode  */
#define BACK 0 
        /* background color                           */
#define PAL 0
        /* medium resolution graphics palette         */
#define BURST 1
        /* color burst                                */
#define XF 3
        /* horizontal offset (every XF-th dot, max=4) */
#define YF 3
        /* vertical offset (every YF-th dot)          */
 
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - */

#define FALSE 0
#define TRUE -1
#define EQ ==

int R, I, J, K, IX, IY, XMAX, YMAX, XMAX1, YMAX1, IR, IC, IRC;
int C0=0;

/* cursor blinking array */
int  BLINK[10] = {1,1,0,0,0,0,0,0,0,0};

int  A[3601], B[3601];

main()
{

INITBC();  /* initialize BASIC_C library (from C_Source) */

XMAX=60*XF; YMAX=60*YF; XMAX1=XMAX-XF; YMAX1=YMAX-YF;

/*  *******************  */
/*  ***  Main Menu  ***  */
/*  *******************  */

main_menu:

SET_SCREEN (1, BURST);  /* medium res */
COLOR (3, BACK, PAL);
CLS(); 
LOCATE (2,32);  PRINT ("S;","F1 CLS ");
LOCATE (4,32);  PRINT ("S;","F2 RUN ");
/*LOCATE (6,32);  PRINT ("S;","F3 LOAD");*/
/*LOCATE (8,32);  PRINT ("S;","F4 SAVE");*/
LOCATE (12,32); PRINT ("S;","Spc SET");
LOCATE (14,32); PRINT ("S;","Esc END");
LOCATE (18,32); PRINT ("S;","Use the");
LOCATE (19,32); PRINT ("S;","arrow  ");
LOCATE (20,32); PRINT ("S;","keypad ");
LOCATE (21,32); PRINT ("S;","to move");
LOCATE (22,32); PRINT ("S;","8 ways.");

for (I=1; I<3600; I++)  A[I]=0;
cleartext();
IX=30*XF; IY=30*YF;

/*  *******************  */
/*  ***  Keyboard   ***  */
/*  *******************  */

get_char:
R = GETKEY(FALSE);
IF (R EQ 0)
  {
  J=(++J)%10;
  PSET(IX,IY,FORE*BLINK[J]);
  goto get_char;
  }
PSET(IX,IY,C0);

switch (R)
  {

  case 32:  /* space bar - flip dot on/off  */
    IR=IX/XF; IC=IY/YF; IRC=IR+60*(IC-1);
    IF (C0>0)  C0=0;   ELSE C0=1;
    A[IRC]=C0; C0=C0*FORE; PSET(IX,IY,C0);
    goto get_char;

  /* oddities in code prevent IX<=0 and IY<=0 */

  case -77: 
    IX=(IX)%XMAX+XF;
    goto move_pen; /* Right */

  case -73:
    IX=(IX)%XMAX+XF;IY=(IY+YMAX-2*YF)%YMAX+YF;
    goto move_pen; /* PgUp */

  case -81:
    IX=(IX)%XMAX+XF;IY=(IY)%YMAX+YF;
    goto move_pen; /* PgDn */

  case -75:
    IX=(IX+XMAX-2*XF)%XMAX+XF;
    goto move_pen; /* Left */

  case -71:
    IX=(IX+XMAX-2*XF)%XMAX+XF;IY=(IY+YMAX-2*YF)%YMAX+YF;
    goto move_pen;/* Home */
    
  case -79:
    IX=(IX+XMAX-2*XF)%XMAX+XF;IY=(IY)%YMAX+YF;
    goto move_pen; /* End */
    
  case -72:
    IY=(IY+YMAX-2*YF)%YMAX+YF;
    goto move_pen; /* Up */
    
  case -80:
    IY=(IY)%YMAX+YF;
    goto move_pen; /* Down */


  case -59:  /* F1 = CLS */
    if (abortmsg("CLEAR"))  goto get_char;
    else  goto main_menu;

  case -60:  /* F2 = RUN */
    life(); 
    goto get_char;

  case 27:  /* Esc */  
    if (abortmsg("Quit?"))  goto get_char;
    SET_SCREEN (2,BURST);  /* back to 80-col:  no WIDTH */
    SET_SCREEN (0,BURST,0,0);
    END(); /* - - - - - - - - - - - - - - - -  END PROGRAM  */

  default:
    BEEP();
    goto get_char;

  }

move_pen:

C0=POINT(IX,IY);
goto get_char;

}


cleartext ()
{
/* ************************* */
/* ***  Clear Text Area  *** */
/* ************************* */

LOCATE (25,1);PRINT (" ;",39);
LOCATE (25,1);PRINT ("S;"," Input:");
while (GETKEY(FALSE)!=0);  /* clear key buffers */
LOCATE (25,1);
return;
}


abortmsg (msg)
char *msg;  /* max length 18 */
            /* returns TRUE if Esc */
{

/* ********************************* */
/* ***  Prompt for Esc to Abort  *** */
/* ********************************* */


int Q;

LOCATE (25,1); PRINT ("SS;",msg," - Space Bar or Esc");
while (GETKEY(FALSE)!=0);  /* clear key buffers */
getq:
Q = GETKEY(TRUE);
switch (Q)
  {
  case 27:
    Q = TRUE;
    break;
  case 32:
    Q = FALSE;
    break;
  default:
    BEEP();
    goto getq;
  }

return(Q);
}



/*  ****************** */
/*  ***  Run LIFE  *** */
/*  ****************** */

life()
{
int G, N, C;

G=1;
LOCATE (25,1); PRINT ("SI;"," Running: ",G);
first_cycle:
FOR (IR=2; IR<59; IR++)
  {
  FOR (IC=2; IC<59; IC++)
    {
    IRC = IR+60*(IC-1);
    N = A[IRC-61]+A[IRC-60]+A[IRC-59]+A[IRC-1]+A[IRC+1]+A[IRC+59]+A[IRC+60]+A[IRC+61];
    C = ((A[IRC] EQ 1) & (N EQ 2 | N EQ 3)) | ((A[IRC] EQ 0) & (N EQ 3));
    PSET(XF*IR,YF*IC,FORE*C);
    B[IRC]=C;
    }
  }
goto  end_cycle;	

second_cycle:
FOR (IR=2; IR<59; IR++)
  {
  FOR (IC=2; IC<59; IC++)
    {
    IRC = IR+60*(IC-1);
    N = B[IRC-61]+B[IRC-60]+B[IRC-59]+B[IRC-1]+B[IRC+1]+B[IRC+59]+B[IRC+60]+B[IRC+61];
    C = ((B[IRC] EQ 1) & (N EQ 2 | N EQ 3)) | ((B[IRC] EQ 0) & (N EQ 3));
    PSET(XF*IR,YF*IC,FORE*C);
    A[IRC]=C;
    }
  }
if (GETKEY(FALSE)!=0)  goto end_life;  /* end while A is correct */

end_cycle:
  G++;
  LOCATE (25,1); PRINT ("SI;"," Running: ",G);
  IF ((G%2) EQ 1) goto first_cycle;
  ELSE  goto second_cycle;

end_life:
cleartext();
return;
}
