 /**      MRMIND3:  PLAY MASTERMIND - PC VERSION
                                                          .
          PETER D. MATTHEWS, JR                1977
                                                          .
          REVISED FOR IBM 327X          AUGUST 1981

          Converted from PL/I for PC           1984
                                                             */
#include "stdio.h"

#define AROW for (s=1; s<=4; s++)

#define ESC   27
#define CR    13
#define BEL    7
#define BS     8
#define SPACE 32
#define LEFT  (-75)
#define RIGHT (-77)

 /***      mrmind:  declarations  (all dimensions +1 for C)  */

      /* panel_2:  display arrays */
char  yr_guess[11][5], my_guess[11][5];
char  yr_exact[11], my_exact[11], yr_near[11], my_near[11];
char  yr_check[11], my_check[11];
char  yr_stab[5], my_stab[5];

      /* panel_1:  display variables */
char  random_p = '9';
int   score = 0;
char  mx_dgt_p = '6';
char  yr_nbr[5], my_nbr[5];

int   icol = 5; /* for positioning guess input */
int   icol2 = 42;
int   random;
int   mx_digit;
int   iturn, icheck, i, j, iend, s, single;
int   msgno = 0;
int   test = FALSE;
char  exact, near;  /* results returned by "eval" */
static char author[] = " Pete Matthews  (c) 1984 ";

main (argc, argv)
int  argc;
char *argv[];

{
  
  /***     mrmind:  control loop                         */
  
  if (argc>1)
    test = TRUE;
  
  scr_setup();  /* set up for routines in PCIO.A */
  scr_clr ();
  instruct ();
  single = yes_no(5);  /* one player or two */

  if (single && yes_no(3))  /* easy game (no prompt for digit) */
    random_p = '5';
  else
    random_p = '9';

  PLAY:
    if (panel_1()==TRUE)
      exit (0);
     
    j = mx_digit;
    icheck = j;
    for (i=1; i<=3; i++) {
      j = j * mx_digit;
      icheck = icheck + j;
    }
  
    AROW   /* set up my number for you to guess */
      my_nbr[s] = roll(mx_digit)+'0';
          
    msgno = 0; 
    iend = FALSE;

    iturn=1;
    do {
      yr_turn ();
      my_turn ();
      iturn++;
    } while ((iturn<=10) && 
        ((my_exact[iturn-1]!='4') || (yr_exact[iturn-1]!='4')));

    panel_2 ();    /* display last line of results */
    show_ans ();   /* show answers */

    if (yes_no(1)) /* game over - play again?*/ 
      goto  PLAY;
    exit(0);  

} /* MRMIND3 */


/***     yr_turn:                                    */
yr_turn ()

{
  panel_2 ();   /* display results and prompt */

  AROW
    yr_guess[iturn][s] = yr_stab[s];

  /*  get exact/near for this guess  */
  if ((iturn==1) || (yr_exact[iturn-1]!='4')) {
    eval (my_nbr, yr_guess, iturn);
    yr_exact[iturn] = exact;
    yr_near[iturn] = near;
  }

  else {
    yr_exact[iturn] = '4';
    yr_near[iturn] = '0';
    }

  if (yr_exact[iturn]=='4') {
    score++;
    iend = TRUE;
  }
  else  {  /* check to see if it's a possible solution */
    j = chk_stab (yr_stab, yr_guess, yr_exact, yr_near);
    yr_check[iturn] = j;
  }

  /* print first player results in two player game */
  if (!single)   {
    scr_rowcol (2+2*iturn,icol+2);
    printf
      ("%c %c %c %c      %c     %c     %c     %2d    ",
   	  yr_guess[iturn][1], yr_guess[iturn][2],
      yr_guess[iturn][3], yr_guess[iturn][4],
  	  yr_exact[iturn], yr_near[iturn], yr_check[iturn], iturn );
  }
  return;
}

/***      my_turn:                                    */
my_turn ()


{
  if ((iturn>1) && (my_exact[iturn-1]=='4'))  {
    AROW    
      my_guess[iturn][s] = my_guess[iturn-1][s];
    my_exact[iturn] = '4';
    my_near[iturn] = '0';
    score--;
    return;
  }

  /* computer guesses - single player game */ 
  if (single)  {

    AROW    /* set up start point for my guess */
      my_stab[s] = roll(mx_digit)+'0';

    if (iturn==1)
      goto fire_1;

    if (roll(10)<random)  /* guess at random */
      goto fire;
      
    /*  make a guess which is not definitely wrong  */

    again:
      j = chk_stab (my_stab, my_guess, my_exact, my_near);
      my_check[iturn] = j;
      if (j<'1')
        goto fire_1;

      /* bump number before trying again */ 
      if (my_stab[4]<mx_dgt_p)
        my_stab[4] = my_stab[4] + 1;
      else {
        my_stab[4] = '1';
        if (my_stab[3]<mx_dgt_p) 
          my_stab[3] = my_stab[3] + 1;
        else {
          my_stab[3] = '1';
          if (my_stab[2]<mx_dgt_p) 
            my_stab[2] = my_stab[2] + 1;
          else {
            my_stab[2] = '1';
            if (my_stab[1]<mx_dgt_p)
              my_stab[1] = my_stab[1] + 1;
            else  my_stab[1] = '1';
          }
        }
      }
    goto again;
  }

  else  {  /* second player guesses - two player game */
    get_stab (my_stab, icol2);
    if (iturn>1)  { 
    	AROW 
    	  if (my_stab[s]!=my_guess[iturn-1][s])
  	      goto fire;
      dmsg(6);
      co(BEL);
      get_stab (my_stab, icol2);
    }
  }
 
  fire:    /*  check the answer to see if it's a possible solution  */
  j = chk_stab (my_stab, my_guess, my_exact, my_near);
  my_check[iturn] = j;

  fire_1:  /* skip checking for first guess or if already checked */
  AROW     
    my_guess[iturn][s] = my_stab[s];

  /*  get exact/near for this guess  */
  eval (yr_nbr, my_guess, iturn);
  my_exact[iturn] = exact;
  my_near[iturn] = near;
  if (my_exact[iturn]=='4') 
    score--;
  return;
}


 /*  chk_stab:  check an input guess against previous attempts  */
chk_stab (stab, guess, ext, nr)

char stab[5], guess[11][5], ext[11], nr[11];

{
  int j;
  
  for (j=1; j<iturn; j++) {
    eval (stab, guess, j);
    if ((ext[j]!=exact) || (nr[j]!=near))
      return(j+'0');  /* conficting guess number */
  }
  end_chk:
  return(' ');
}


/***     eval:  evaluate guess, return result in exact & near    */
eval (nbr, guess, nturn)

char   nbr[5];     /* answer to be evaluated against */ 
char   guess[11][5];  /* use [nturn][*] */
int    nturn;

{
  int    i, j, s;
  char   work_nbr[5], work_guess[5];
  exact = '0';
  near = '0';
    
  AROW  {
    work_nbr[s] = nbr[s];
    work_guess[s] = guess[nturn][s];
  }

  /*  exact  */
  for (i=1; i<=4; i++) {
    if (nbr[i]==guess[nturn][i]) {
      exact++;
      work_nbr[i] = '0';
      work_guess[i] = '0';
    }
  }

  /*  near  */ 
  for (i=1; i<=4; i++) {
    if (work_nbr[i]!='0')  {
      for (j=1; j<=4; j++) {
        if (work_nbr[i]==work_guess[j]) {
          near++;
          work_guess[j] = '0';
          goto end_nz;
        }
      }
    } 
  end_nz: ;
  }

  return;
}


 /**   ROLL:  RETURNS RANDOM INTEGER FROM 1 TO N   */
roll (n) 
int  n;

{
         int        iy1;
         double     fr, frand();
  static int        first = TRUE;
         int        timer[2];


  /*  INITIALIZE ON FIRST PASS  */
  if (first==TRUE) 
  {
    timer[0] = _peek (0x6c, 0x40); /* low word of PC timer (offset, segment) */
    timer[1] = _peek (0x6d, 0x40); 
    iy1 = (128*timer[0]) + timer[1];
    srand (iy1); /* seed random nbr generator */  
    first = FALSE;
  }
  
  fr = frand();
  iy1 = (int) (fr * n);
  iy1 %= n;
  return (++iy1);
}


 /*  panel_2:  game screen management   */

panel_2 ()

{
	int it1;

  scr_cursoff ();  /* cursor off */
   
  dmsg(msgno); /* display message */
  msgno = 0;
  it1 = iturn-1;
 
  if (iturn>1)  {
    scr_rowcol (2+2*it1,icol+2);
    if (single)  {
      scr_rowcol (2+2*it1,icol+2);
      printf
  	    ("%c %c %c %c      %c     %c     %c     %2d    ",
     	  yr_guess[it1][1], yr_guess[it1][2],
        yr_guess[it1][3], yr_guess[it1][4],
  	    yr_exact[it1], yr_near[it1], yr_check[it1], it1 );
  	}
  	else
      scr_rowcol (2+2*it1,icol2+2);
	  printf
  	    ("%c %c %c %c      %c     %c     %c",
        my_guess[it1][1], my_guess[it1][2],
        my_guess[it1][3], my_guess[it1][4],  
        my_exact[it1], my_near[it1], my_check[it1]  );
  }
   
  else  {  /* First Turn Only */
    scr_clr ();  /* clear screen */  
    scr_rowcol (2,icol+1);  /* locate from (0,0) */
  	printf 
        ("YOUR Guess  Exact Near Check   Turn  ");
    printf 
        (" MY Guess   Exact Near Check");
    scr_rowcol (0,2);
    printf
        ("===>                        ");
    if (single)  printf
        ("Your number:  %c %c %c %c",      
        yr_nbr[1], yr_nbr[2], yr_nbr[3], yr_nbr[4] );
    else  printf
        ("         ===> ");
    if (test)  
      show_ans();

    AROW  {
      yr_stab[s] = SPACE;
      my_stab[s] = SPACE; 
    }
  }
  
  scr_curson();  /* cursor on */

  if (iend==TRUE)
    return(TRUE);
  
  get_stab (yr_stab, icol);
  if (iturn>1)  {
  	AROW 
  	  if (yr_stab[s]!=yr_guess[it1][s])
  	    goto ret;
    dmsg(6);
    co(BEL);
    get_stab (yr_stab, icol);
  }
  ret:
  return (FALSE);
}


 /*  yes_no:  question?  */
yes_no(n)
int n;
{
  int c;
  
  ask:
  dmsg(n);
  c = inkey();
  if ((c==ESC) && (n!=2))
    exit(0); /* not if quit msg */
  if (c=='Y' || c=='y')
    return (TRUE);
  if (c=='N' || c=='n')
    return (FALSE);
  co(BEL);
  goto ask;
}


 /**    dmsg:  display message by msgno   */
dmsg (n)

int n;

{
  scr_rowcol (24, 0);  /* screen row,col from 0,0=topleft */
  printf ("                                                   Running Score: %3d",score);
  scr_rowcol (24, 0);  /* screen row,col from 0,0=topleft */
  if (n==1)
    printf ("GAME OVER - Play Again (Y or N)?      ");
  else if (n==2)	  
    printf ("Quit (Y or N)?                        ");
  else if (n==3)	
    printf ("Easy game (Y or N)?                   ");
  else if (n==4)  /* not used - rely on ANSI.SYS */	
    printf ("Do you have a color display (Y or N)? ");
  else if (n==5) 	
    printf ("Play against the computer (Y or N)?   ");
  else if (n==6) 	
    printf ("That's the same guess as last time!   ");
} 



 /**   inkey:  returns input keystroke, extended codes negative  */
inkey ()
{
  int k;
  k = ci ();
  if (k==0)
    k = - ci ();
  return(k);
}

 /* panel_1:  get nbr and start game */
panel_1()

{
  mx_digit = mx_dgt_p-'0';  /* always default (no prompt) */
  random = 9-(random_p-'0');
  
  AROW   /* set up your number for me to guess!!! (no prompt) */
    yr_nbr[s] = roll(mx_digit)+'0';

  /* initialization */
  for (i=1; i<=10; i++)  {
    yr_check[i] = ' ';
    my_check[i] = ' ';
  }
  iend = FALSE;
  iturn = 1;
}


/*  get_stab:  get a guess from a player */
get_stab (stab, ncol)

char stab[5];
int  ncol;

{
  int c;
  int  ic = 1;

  get_key: 
  scr_rowcol (0, ncol+2*ic);

  c = inkey();
  
  if ((c==LEFT) || (c==BS) || (c=='-'))  {
    ic--;
    if (ic<1)
      ic = 4;
    goto get_key;
  }
  
  if ((c==RIGHT) || (c=='+'))  {
    ic %= 4;
    ic++;
    goto get_key;
  }

  if (c==CR)  {
  	AROW  {
  		if (stab[s]<'1')  {
  			ic = s;
  			co(BEL); /*beep*/
  			goto get_key;
  		}
  	}
    return(FALSE);
  }

  if (c==ESC)  {
  	if (yes_no(2))  {
  		scr_clr ();
      exit(0); /* END GAME */
    }
    co (BEL);
    goto get_key;
  }

  if (c==SPACE || ('1'<=c && c<=mx_dgt_p))  {
    co (c); /* print digit */
    stab[ic] = c;
    ic %= 4;
    ic++;
    goto get_key;
  }

  	co(BEL); /*beep*/
  	goto get_key;
}


/*  show answers for test mode or end of game  */
show_ans ()
{
  scr_rowcol (1,icol+2);
  printf
      ("%c %c %c %c",      
      my_nbr[1], my_nbr[2], my_nbr[3], my_nbr[4] );
      scr_rowcol (1,icol2+2);
  printf
      ("%c %c %c %c",      
      yr_nbr[1], yr_nbr[2], yr_nbr[3], yr_nbr[4] );
}


/*  instruct:  instructions for game  */
instruct ()
{
  scr_rowcol (1,0);
 	printf (
  "  MASTERMIND                                    Pete Matthews   (c) 1984\n");
	printf (
  "                                                                        \n");
	printf (
  "  The object of MASTERMIND is to guess a four-digit number.  Each digit \n");
	printf (
  "  is from one to six (1, 2, 3, 4, 5, 6).  After each guess, you will be \n");
	printf (
  "  told how many digits were exactly right (exact), but not which ones.  \n");
	printf (
  "  You will also be told which of the digits were right, not counting the\n");
	printf (
  "  exact hits, but were in the wrong place (near).  Your running score   \n");
	printf (
  "  indicates how many more (or fewer) turns your opponent took than you. \n");
	printf (
  "  If a guess could not possibly be correct, the number of the turn which\n");
	printf (
  "  proves it false is shown (check).                                     \n");
	printf (
  "                                                                        \n");
	printf (
  "  The keys which you may use in making a guess are:                     \n");
	printf (
  "                                                                        \n");
	printf (
  "      1, 2, 3, 4, 5, 6               Select a digit for your guess      \n");
	printf (
  "      Left arrow, Backspace, -       Position one digit left            \n");
	printf (
  "      Right arrow, +                 Position one digit right           \n");
	printf (
  "      Space bar                      Blank out a digit                  \n");
	printf (
  "      Esc                            Quit game (exit to DOS)            \n");
	printf (
  "      Enter                          Enter a guess (end turn)           \n");
}
  